#include <Arduino.h>
#include "WiFi.h"
#include <esp_now.h>
uint8_t rightAddress[] = {0x2C, 0x3A, 0xE8, 0x4D, 0xC3, 0x8D}; //2C:3A:E8:4D:C3:8D 2C:3A:E8:4D:C3:8D
//2C:3A:E8:4D:75:9A
uint8_t leftAddress[] = {0x2C, 0x3A, 0xE8, 0x4D, 0x75, 0x9A}; //{0xEC, 0xFA, 0xBC, 0x8D, 0xBC, 0x93}; //{0x24, 0x62, 0xAB, 0xDD, 0x0B, 0x78};
uint8_t broadcastAddress[] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};

typedef struct struct_message
{
    int kod;
} struct_message;
struct_message leftLaneData;
struct_message rightLaneData;
esp_now_peer_info_t peerInfoLeft;
esp_now_peer_info_t peerInfoRight;

void espSendData(int lane, int m)
{
    if (lane == 1)
    { //leva draha
        leftLaneData.kod = m;
        // Serial.println("ESPNow sent data");
        esp_now_send(leftAddress, (uint8_t *)&leftLaneData, sizeof(leftLaneData));
    }
    if (lane == 2)
    { //prava draha
        rightLaneData.kod = m;
        // Serial.println("ESPNow right sent data");
        esp_now_send(rightAddress, (uint8_t *)&rightLaneData, sizeof(rightLaneData));
    }
}

void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status)
{
    // Serial.print("\r\nLast Packet Send Status:\t");
    // Serial.println(status == ESP_NOW_SEND_SUCCESS ? "Delivery Success" : "Delivery Fail");
    //  Serial.print("zprava, ktera byla odeslana:\t");
    //  Serial.println(leftLaneData.kod);
}

void initEspNow()
{
    // WiFi.mode(WIFI_STA);
    WiFi.mode(WIFI_STA);
    // Get Mac Add
    // Serial.print("Mac Address: ");
    // Serial.print(WiFi.macAddress());
    // Serial.println("ESP32 ESP-Now Broadcast");
    // Initializing the ESP-NOW
    if (esp_now_init() != 0)
    {
        Serial.println("Problem during ESP-NOW init");
        return;
    }
    memcpy(peerInfoLeft.peer_addr, leftAddress, 6);
    peerInfoLeft.channel = 4;
    peerInfoLeft.encrypt = 0;

    memcpy(peerInfoRight.peer_addr, rightAddress, 6);
    peerInfoRight.channel = 4;
    peerInfoRight.encrypt = 0;

    if (esp_now_add_peer(&peerInfoLeft) != ESP_OK)
    {
        Serial.println("Failed to add peer");
        return;
    }
    else Serial.println("left perr add");
    if (esp_now_add_peer(&peerInfoRight) != ESP_OK)
    {
        Serial.println("failed right to add peer");
        return;
    }
    else Serial.println("right peer add");
}