#include <Arduino.h>
#include <freertos/task.h>
#include <driver/dac.h>
#include "myBluetooth.h"
#include "beam.h"
#include "myEspNow.h"
#include "tisr.h"
#include "I2C.h"
#include "parser.h"

#define ADC 36

#define button 14

unsigned long batteryTime = 0; //cas cteni baterie
unsigned long batteryDeb = 10000;
unsigned long analogValue = 0; //analogova hodnota vyctena z adc
unsigned long btnTime = 0; //cas stisku talcitka
unsigned long btnTimeDeb = 3000;
bool btnChange = false;
unsigned long t =0; //cas pro startovani

void getBattery() //pomoci ADC zjistit stav na baterii.
{
  long td = millis();
  if (td - batteryTime > batteryDeb) //každých deset 10s
  {
    int analogValue = analogRead(ADC);
    String s = "B";
    // Serial.print("napeti na baterii: ");
    float bat = (analogValue * 12.8) / 4095;

    Serial.println(s += bat);
    writeBT(s);
    batteryTime = td;
  }
}

void IRAM_ATTR btnISR()
{ //tlacitko pro spusteni startovni sekvence
  long td = millis();
  if (td - btnTime > btnTimeDeb) //citlivost tlacitka 3ss
  {
    btnChange = true;
    btnTime = td;
  }
}
void setup()
{
  // put your setup code here, to run once:
  Serial.begin(9600);
  // Serial.println("start");
  pinMode(button, INPUT_PULLUP);
  attachInterrupt(button, btnISR, RISING);
  initBT();
  initBeam();
  initEspNow();

  initTisr();
  initEEPROM();
  setStart(false);
  // manualStart = true;
}
void loop()
{ //analoValueportGetCoreID() = 1;
  // put your main code here, to run repeatedly:

  readBT();
  priblizuj();

  // Serial.print("getStartPosition");
  // Serial.println(getStartPosition());

  if (!isStart())
  {
    checkIsr();
  }
  if (isSA()) //je SA povoleno
  {
    t = millis();
    startSA(t);
  }
  if (isSC())
  {
    t = millis();
    start(t);
  }
  if (!isDataRead())
  {
    getBattery();
  }
  if (btnChange)
  {
    if (isManualStart())
    {
      setB(1);
      setSC(true);
      start(millis());
      btnChange = false;
    }
  }
}
